;; -*- encoding: utf-8-unix; -*-
;; * autoload
(mapc 'load (directory-files (expand-file-name "_autoload" init-dir) t "\\.el\\'"))

;; * working dir
(setq sand-box (expand-file-name "sandbox/" init-dir))
(cd sand-box)

;; * 打开特定文件时使用 View 模式
(add-hook 'find-file-hook
          '(lambda ()
             (when
                 (and
                  (file-exists-p (buffer-file-name))                ; 已存在文件
                  (member (file-name-extension (buffer-name))
                          '("el" "bak" "txt")))                     ; 匹配扩展名
               (view-mode)
               )))

;; * max
(setq max-lisp-eval-depth   1000        ;lisp最大执行深度   500
      max-specpdl-size      10000       ;最大容量           1000
      kill-ring-max         1024        ;kill ring          60
      undo-outer-limit      5000000     ;撤销限制           12000000
      mark-ring-max         1024        ;mark ring          16
)

;; * Common
(setq message-log-max         t        ;完整的 message-log
      inhibit-startup-message t        ;关闭起动时闪屏
      initial-scratch-message          ;初始内容
      (purecopy "\
;; In sandbox
"))

;; * coding-system
;; 语言环境
;(set-language-environment 'utf-8)
;(set-clipboard-coding-system 'utf-8)            ;; 剪切板，用于和其他程序之间复制内容
(setq default-buffer-file-coding-system  'utf-8-unix)     ; 文件
;; (when (eq system-type 'windows-nt)
;;   (setq
;;       default-file-name-coding-system   'chinese-iso-8bit ; 文件名
;;       default-keyboard-coding-system    'chinese-iso-8bit ; 键盘输入，用于输入法。
;;       default-terminal-coding-system    'chinese-iso-8bit ; 终端显示的编码方式。
;;       ))

;; * safe-local-variable
(setq safe-local-variable-values '(
      (encoding . utf-8)
      (encoding . utf-8-unix)
      (encoding . utf-8-emacs-unix)
))

;; * help
(setq help-xref-following nil)

;; * 开启服务器模式
;(server-start)

